#include<bits/stdc++.h>
using namespace std;
int t,id;
int n,m,c,f;
int ma[1050][1050]{0};
int spera[1050][1050]{0},speco[1050][1050]{0};
long long int cans=0,fans=0;
int main(){
	freopen("plant.in","r",stdin);
	freopen("plant.out","w",stdout);
	cin>>t>>id;
	while(t--){
		for(int i=1;i<=1020;i++){
			for(int j=1;j<=1020;j++){
				spera[i][j]=speco[i][j]=ma[i][j]=0;
			}
		}
	cans=0,fans=0;
	cin>>n>>m>>c>>f;
	for(int i=1;i<=n;i++){
		char qs[1050];
		cin>>qs;
		for(int j=1;j<=m;j++){
			ma[i][j]=(qs[j-1]-'0'+1)%2;
		}
	}
	for(int i=1;i<=n;i++){
		for(int j=m;j>=1;j--){
			if(ma[i][j]==1)spera[i][j]=spera[i][j+1]+1;
			else spera[i][j]=0;
		}
	}
	for(int j=1;j<=m;j++){
		for(int i=n;i>=1;i--){
			if(ma[i][j]==1)speco[i][j]=speco[i+1][j]+1;
			else spera[i][j]=0;
		}
	}
	for(int i=1;i<=n;i++){
		for(int j=1;j<=m;j++){
			long long int can=0;
			for(int k=2;k<=speco[i][j]-1;k++){
				can+=spera[i+k][j]-1;		
			}
			cans=(cans+can*(spera[i][j]-1))%998244353;
		}
	}cout<<c*cans<<" ";
	for(int i=1;i<=n;i++){
		for(int j=1;j<=m;j++){
			long long int fan=0;
			for(int k=2;k<=speco[i][j]-1;k++){
				fan+=(spera[i+k][j]-1)*(speco[i+k][j]-1);		
			}
			fans=(fans+fan%998244353*(spera[i][j]-1))%998244353;
		}
	}cout<<f*fans<<endl;
	
	}
	return 0;
}